#/bin/busybox sh
# (C) Klaus Knopper 2020
# LICENSE: GPL V2

# busybox internal reboot, halt and poweroff commands don't
# trigger actions in /etc/inittab and use syscalls instead, so
# we would get an imediate reset/halt instead of calling our
# shutdown scripts.

# So, use signals instead, which will trigger the expected behavior configured
# in /etc/inittab.

case "$1" in
 --force|-f)  FORCE=true;;
 --nosync|-n) NOSYNC="-n";;
 -h) true;;
 --help)  echo "Usage: $0 [-f]" >&2; exit 0;; 
esac

case "$0" in
	*reboot)                     [ -n "$FORCE" ] && /bin/busybox reboot -f $NOSYNC   || kill -QUIT 1;;
	*halt)                       [ -n "$FORCE" ] && /bin/busybox halt -f $NOSYNC     || kill -INT 1;;
	*poweroff|*shutdown)         [ -n "$FORCE" ] && /bin/busybox poweroff -f $NOSYNC || kill -INT 1;;
esac
